
package de.ivu.elect.presentation.gebietsbaum.menu;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.gebietsbaum.AnzahlWahlberechtigteErfassungState;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

@Named(AnzahlWahlberechtigteDeleteAllMenuItemEntry.COMPONENT_NAME)
public class AnzahlWahlberechtigteDeleteAllMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "anzahlWahlberechtigteDeleteAllMenuItemEntry";

  @Inject
  private transient AnzahlWahlberechtigteErfassungState anzahlWahlberechtigteErfassungState;

  public AnzahlWahlberechtigteDeleteAllMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.ANZAHL_WAHLBERECHTIGTE_ZURUECKSETZEN) && isImportMoeglich();
  }

  private boolean isImportMoeglich() {
    return isGebietSelected() && anzahlWahlberechtigteErfassungState.isImportMoeglich(getSelectedGebiet().getWahl());
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getBearbeitenGebietSecurity();
  }

  @Override
  protected boolean isDisabledInternal() {
    return !isGebietSelected() || getSelectedGebiet().hasUebergeordnetesGebiet();
  }

  @Override
  protected boolean isAjax() {
    return true;
  }

  @Override
  public String getTargetViewId() {
    return null;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirmAll";
  }

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), getMessage("entity.mehrzahl.GEBIET.ANZAHL_WAHLBERECHTIGTE"));
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete.all.entities";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconDelete();
  }
}
